% function [D,Db,Dv]=genbars(N,K,s);
% generate bars data N, KxK vertical bars
%
% D   = data matrix (N x K*K)
% Dv  = indicator of true causes 1=vertical, 0=horizontal  (N x 1)
% Db  = indicator of which bars are on (N x K)
% 
% s is the standard deviation of the noise
% the bar intensities range uniformly from 0 to 5

function [D,Db,Dv]=genbars(N,K,s);

d=zeros(K);
D=zeros(N,K*K);
Dv=zeros(N,1);
Db=zeros(N,K);

for i=1:N,
  if rand<0.5; % vertical
    Dv(i)=1;

    j=rand(K,1)<0.4; % bar on or off
    Db(i,:)=j';

    k=rand(K,1)*5;  % real valued intensity of bar
    t=k.*j;
    d=(ones(K,1)*t')';
    D(i,:)=d(:)'+randn(1,K*K)*s;
  else % horizontal
    Dv(i)=0;

    j=rand(K,1)<0.4; % bar on or off
    Db(i,:)=j';

    k=rand(K,1)*5;  % real valued intensity of bar
    t=k.*j;
    d=(t*ones(1,K))';
    D(i,:)=d(:)'+randn(1,K*K)*s;
  end;
end;