% Show hinton diagrams of weights and lots of other things

clg;

% plot biases

axes('position',[0.05,0.85,0.9,0.04]);
rng=hinton(b1');  
text(n1+1,0.5,['scale= ' num2str(rng) ' v= ' num2str(v1)]);
title('Bias of top hidden layer');

% weights W12

axes('position',[0.05,0.70,0.9,0.08]);
hinton(W12');  
title('Weights from top layer to middle layer');

% biases and weights at layer 2

axes('position',[0.05,0.59,0.9,0.06]);
hinton(b2');
title('Biases of middle hidden layer');

axes('position',[0.5,0.58,0.01,0.01]);
axis('off');
th=text(0,0,'Weights from middle layer to bottom layer');
set(th,'HorizontalAlignment','center');

rng=ceil(max(abs(W23(:))));
for k=1:n2,
  axes('position',[0.05+0.9*(k-1)/n2,0.35,0.9/n2,0.2]);
  hinton(reshape(W23(:,k),P,2),rng);
end;

% plot evolution of some of the weights in W12

axes('position',[0.05,0.1,0.15,0.2])
% plot(params(1:fix(cyc/savestep),1:n1*n2));
plot(params(1:ceil(log(cyc/savestep)):fix(cyc/savestep),1:ceil(log(n1*n2)):n1*n2));
title('W12');
xlabel('time');

% histogram of weights W23
axes('position',[0.25,0.1,0.15,0.2])
hist(params(fix(cyc/savestep),n1*n2+1:n1*n2+n2*n3));
title('W23 hist');

% log variances at three layers
axes('position',[0.45,0.1,0.15,0.2])
semilogy(params(1:fix(cyc/savestep),n1*n2+n2*n3+n1+n2+n3+(1:3)));
title('log vars');
xlabel('time');

% activities of some of the units  in two colors for left/right shifts 

axes('position',[0.62,0.1,0.15,0.2]);
id=Dd; plot(activ(id,1),activ(id,2),'g.');  hold on;
plot(activ(~id,1),activ(~id,2),'r.');
title('hid. units 1 & 2');

axes('position',[0.81,0.1,0.15,0.2]);
id=Dd; plot(activ(id,3),activ(id,4),'g.');  hold on;
plot(activ(~id,3),activ(~id,4),'r.');
title('hid. units 3 & 4');

fprintf(' time= %g\n',toc);
drawnow;
