
function samp=twogauss(mun,vn,mup,vp);

  tiny=exp(-700);
  % probability of 0 under negative and positive Gaussian 
  % has to be equal, from this we compute mixing proportions
  
  pneg=1/sqrt(2*pi*vn)*exp(-(mun^2)/(2*vn));
  ppos=1/sqrt(2*pi*vp)*exp(-(mup^2)/(2*vp));
  alpha=(ppos+tiny)/(ppos+pneg+2*tiny); % weight of negative portion

  % sample

  zn=mun/sqrt(vn);
  zp=mup/sqrt(vp);
  zna=sqrt(log(2*pi)-2*log(alpha+tiny));
  zpa=sqrt(log(2*pi)-2*log(1-alpha+tiny));

  th=2.0; % 

  if (zna>th & zp < -th) | (zpa>th & zn >th) | (zn > th & zp < -th),
    intneg=alpha*cumnorm(mun,vn);
    intpos=(1-alpha)*cumnorm(-mup,vp);
    inttot=intneg+intpos;
    if inttot==0,
      samp=0;
      return;
    end;
    pneg=intneg/inttot;

    if rand<pneg, % sample from negative portion 
      if zn>1,    % use tail sampling
	samp=-samptail(-mun,vn);
      else        % use simple rejection sampling 
	samp=-samprej(-mun,vn);
      end;
    else          % sample from positive portion
      if zp<-1,
	samp=samptail(mup,vp);
      else        % use simple rejection sampling 
	samp=samprej(mup,vp);
      end;
    end;
  else
    samp=sampmix(alpha,mun,vn,mup,vp);
end;
  
